質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

90.33%

  • Python 3.x

    7412questions

    Python 3はPythonプログラミング言語の最新バージョンであり、2008年12月3日にリリースされました。

  • Mecab

    194questions

    Mecabは、オープンソースの形態素解析エンジンです。 言語、辞書、コーパスに依存しない汎用的な設計を基本方針としています。 Mecabの由来は、開発者の好物である和布蕪(めかぶ)から名づけられました。

Python3で呼び出されたMecabの結果をWebブラウザ上で表示させたい。

解決済

回答 1

投稿 編集

  • 評価
  • クリップ 0
  • VIEW 316

testcase

score 9

お世話になります。

#!/usr/bin/env python3.4
# -*- coding: utf-8 -*-
from natto import MeCab

mc = MeCab()

text = "おはようございます。"

ma = mc.parse(text)

print("Content-Type: text/html; charset=utf-8\n\n")
print("""
<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8x">
<title>CGIスクリプト</title>
</head>
<body>
<pre>
""")
print(ma)
print("""
</pre>
</body>
</html>
""")


このようなMecabの解析結果をWebブラウザ上で表示するプログラムを書きました。
ファイル名をsample.pyとでもすると、

 % python3 sample.py


と入力すると以下のように表示してくれます。

Content-Type: text/html; charset=utf-8


<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8x">
<title>CGIスクリプト</title>
</head>
<body>
<h1>CGIスクリプト</h1>
<p>これはサーバの実行結果として生成されたHTMLです</p>
<pre>

おはよう    感動詞,*,*,*,*,*,おはよう,オハヨウ,オハヨー
ござい    助動詞,*,*,*,五段・ラ行特殊,連用形,ござる,ゴザイ,ゴザイ
ます    助動詞,*,*,*,特殊・マス,基本形,ます,マス,マス
。    記号,句点,*,*,*,*,。,。,。
EOS

</pre>
</body>
</html>

この結果を、できれば http://hoge.com/sample.pyなどと書いてWebブラウザ上で表示させたいと考えているのですが、上手く表示されません。
サーバはXserverを利用しています。

.htaccessでの設定がおかしいのかと考えましたが、

#!/usr/bin/env python3

import datetime

#フォーマット文字列の作成
html_body = """
<html><body>
{0.year:d}/{0.month:d}/{0.day:d} {0.hour:d}:{0.minute:d}:{0.second:d}
</body></html>"""

now=datetime.datetime.now()

print("Content-type: text/html\n")
print(html_body.format(now))


等も作りましたが、こちらは結果がブラウザ上にきちんと表示されます。
.htaccessはこのように設定しています。

AddHandler cgi-script .py


どのようにすればいいのかご教授いただけますと幸甚です。
よろしくおねがいします。

その後、以下の事柄を試しました。

#!/usr/bin/env python3.4
# -*- coding: utf-8 -*-

import sys
import io
sys.stdout = io.TextIOWrapper(sys.stdout.buffer, encoding='utf-8')
#sys.stdout.write('Content-type: text/html; charset=UTF-8\n\n')

import cgi
# enable debugging
import cgitb
cgitb.enable()

from natto import MeCab

#mc = MeCab.Tagger('-Ochasen')

text = "おはようございます。"

#ma = mc.parse(text)

print("Content-Type: text/html; charset=utf-8\n\n")
print("""
<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8x">
<title>CGIスクリプト</title>
</head>
<body>
<pre>
""")
#print(ma)
print(text)
print("""
</pre>
</body>
</html>
""")

このようにすることで、少なくとも文字コードはUTF-8に統一され、
Mecabを利用しない範囲においては、表示されるようにはなりました。
まだMecabについては上手く表示ができておりませんので、
引き続き試していきたいと思います。

その後、この直上のプログラムで、コメント記号を外した

mc = MeCab.Tagger('-Ochasen')


は、コマンドライン上での実行と併せて

mc = MeCab()


とした方がよいことがわかりました。
しかし、コメント記号を外すと
いずれでも500 internal Server Errorとなります。
ちなみに、このmcをprint文で表示させると、

<natto.mecab.MeCab model=<cdata 'mecab_model_t *' 0x55f5d313c190>, 
 tagger=<cdata 'mecab_t *' 0x55f5d31dc950>, 
 lattice=<cdata 'mecab_lattice_t *' 0x55f5d31463a0>, 
 libpath="/home/.../bin/mecab/lib/libmecab.so", 
 options={}, 
 dicts=[<natto.dictionary.DictionaryInfo dictionary=
 <cdata 'mecab_dictionary_info_t *' 0x55f5d3133660>, 
 filepath="/home/.../bin/mecab/lib/mecab/dic/ipadic/sys.dic", 
  charset=utf-8, type=0>], 
 version=0.996>


このようになります。
引き続き調査します。
よろしくお願いします。

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

質問への追記・修正、ベストアンサー選択の依頼

  • KojiDoi

    2018/07/18 03:08

    pythonではなくサーバ設定の問題でしょう。 Xserverではnginx使っているようですから、"nginx cgi 設置" などググって見てはどうでしょう。

    キャンセル

  • testcase

    2018/07/18 03:23

    ありがとうございます。500と返ってきます。エラーログですが、「End of script output before headers: sample.py」と出ます。public_html内でPython関連のディレクトリを作成し、その中で実行しています。nginxってそんな状況なのですね。ありがとうございます。調べてみます。

    キャンセル

  • testcase

    2018/07/19 21:48

    FCGIについて調べました。fcgiwrapをインストールしようと考え、git cloneでダウンロードしてからautoreconfした後、configureすると、checking for 「FCGX_Init in -lfcgi... no」となって、configureできませんでした。これにつきましてご教示いただけませんでしょうか?よろしくお願いします。

    キャンセル

回答 1

checkベストアンサー

+1

ずっと内部エラーのままじゃしょうがないので、とりあえずtracebackでも見てみませんか。

#!/usr/bin/env python3.4
# -*- coding: utf-8 -*-

import sys
import io
sys.stdout = io.TextIOWrapper(sys.stdout.buffer, encoding='utf-8')
#sys.stdout.write('Content-type: text/html; charset=UTF-8\n\n')

import cgi
# enable debugging
import cgitb
cgitb.enable()

from natto import MeCab
import traceback



text = "おはようございます。"

try:
    mc = MeCab.Tagger('-Ochasen')
    ma = mc.parse(text)
except:
    traceback_txt = traceback.format_exc()

print("Content-Type: text/html; charset=utf-8\n\n")
print("""
<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8x">
<title>CGIスクリプト</title>
</head>
<body>
<pre>
""")
#print(ma)
print(text)
print(traceback_txt)
print("""
</pre>
</body>
</html>
""")

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2018/07/30 22:23 編集

    ありがとうございます。

    少し修正して以下のようにしてみました。

    ```Python
    #!/usr/bin/env python3.4
    # -*- coding: utf-8 -*-

    import logging
    import traceback

    import sys
    import io

    sys.stdout = io.TextIOWrapper(sys.stdout.buffer, encoding='utf-8')

    import cgi
    # enable debugging
    import cgitb
    cgitb.enable()

    from natto import MeCab

    text = "おはようございます。"

    try:
    mc = MeCab()
    ma = mc.parse(text)

    except Exception as e:
    logging.error(traceback.format_exc())
    #traceback.print_exc()

    print("Content-type: text/html; charset=utf-8\n\n")
    #print()
    print("""
    <!DOCTYPE html>
    <html>
    <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
    <title>CGIスクリプト</title>
    </head>
    <body>
    <h1>CGIスクリプト</h1>
    <p>これはサーバの実行結果として生成されたHTMLです</p>
    <pre>
    """)
    print(ma)
    print(text)
    print("""
    </pre>
    </body>
    </html>
    """)
    ```

    この結果、MeCabの処理はError Catchされており、
    結果としてブラウザ上で
    maなんて変数は未定義ですよと言われてしまいました。

    ```Python
    NameError Python 3.4.5: /usr/bin/python3.4
    Mon Jul 30 22:21:38 2018
    A problem occurred in a Python script. Here is the sequence of function calls leading up to the error, in the order they occurred.

    /home/.../public_html/python/sample1.py in ()
    53 """)
    54 #print(mc)
    => 55 print(ma)
    56 print(text)
    57 #print(sys.version)
    builtin print = <built-in function print>, ma undefined
    NameError: name 'ma' is not defined
    args = ("name 'ma' is not defined",)
    with_traceback = <built-in method with_traceback of NameError object>
    ```

    キャンセル

  • 2018/07/30 22:28

    上記のmaのエラーはその後tryの前で
    ma = ""
    などとすればエラーはなくなりました。

    キャンセル

  • 2018/07/30 22:32

    私の回答どおりにするとどうなりますか?

    キャンセル

  • 2018/07/30 23:50

    このような感じになりました。

    Content-Type: text/html; charset=utf-8

    <!DOCTYPE html>
    <html>
    <head>
    <meta charset="utf-8x">
    <title>CGIスクリプト</title>
    </head>
    <body>
    <pre>

    おはようございます。
    <!--: spam
    Content-Type: text/html

    <body bgcolor="#f0f0f8"><font color="#f0f0f8" size="-5"> -->
    <body bgcolor="#f0f0f8"><font color="#f0f0f8" size="-5"> --> -->
    </font> </font> </font> </script> </object> </blockquote> </pre>
    </table> </table> </table> </table> </table> </font> </font> </font><body bgcolor="#f0f0f8">
    <table width="100%" cellspacing=0 cellpadding=2 border=0 summary="heading">
    <tr bgcolor="#6622aa">
    <td valign=bottom>&nbsp;<br>
    <font color="#ffffff" face="helvetica, arial">&nbsp;<br><big><big><strong>NameError</strong></big></big></font></td
    ><td align=right valign=bottom
    ><font color="#ffffff" face="helvetica, arial">Python 3.6.5: /home/.../.pyenv/versions/anaconda3-5.2.0/bin/python3<br>Mon Jul 30 23:45:29 2018</font></td></tr></table>

    <p>A problem occurred in a Python script. Here is the sequence of
    function calls leading up to the error, in the order they occurred.</p>
    <table width="100%" cellspacing=0 cellpadding=0 border=0>
    <tr><td bgcolor="#d8bbff"><big>&nbsp;</big><a href="file:///home/.../h2o.jp/public_html/python/sample2.py">/home/.../h2o.jp/public_html/python/sample2.py</a> in <strong><module></strong>()</td></tr>
    <tr><td><font color="#909090"><tt>&nbsp;&nbsp;<small>&nbsp;&nbsp;&nbsp;39</small>&nbsp;#print(ma)<br>
    </tt></font></td></tr>
    <tr><td><font color="#909090"><tt>&nbsp;&nbsp;<small>&nbsp;&nbsp;&nbsp;40</small>&nbsp;print(text)<br>
    </tt></font></td></tr>
    <tr><td bgcolor="#ffccee"><tt>=&gt;<small>&nbsp;&nbsp;&nbsp;41</small>&nbsp;print(traceback_txt)<br>
    </tt></td></tr>
    <tr><td><font color="#909090"><tt>&nbsp;&nbsp;<small>&nbsp;&nbsp;&nbsp;42</small>&nbsp;print("""<br>
    </tt></font></td></tr>
    <tr><td><font color="#909090"><tt>&nbsp;&nbsp;<small>&nbsp;&nbsp;&nbsp;43</small>&nbsp;&lt;/pre&gt;<br>
    </tt></font></td></tr>
    <tr><td><small><font color="#909090"><em>builtin</em> <strong>print</strong>&nbsp;= &lt;built-in function print&gt;, traceback_txt <em>undefined</em></font></small></td></tr></table><p><strong>NameError</strong>: name 'traceback_txt' is not defined
    <br><tt><small>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</small>&nbsp;</tt>args&nbsp;=
    ("name 'traceback_txt' is not defined",)
    <br><tt><small>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</small>&nbsp;</tt>with_traceback&nbsp;=
    &lt;built-in method with_traceback of NameError object&gt;


    <!-- The above is a description of an error in a Python program, formatted
    for a Web browser because the 'cgitb' module was enabled. In case you
    are not reading this in a Web browser, here is the original traceback:

    Traceback (most recent call last):
    File "sample2.py", line 41, in &lt;module&gt;
    print(traceback_txt)
    NameError: name 'traceback_txt' is not defined

    -->

    キャンセル

  • 2018/07/30 23:58

    妙ですね。except節に行ってないか、行っているけど代入できていない?

    キャンセル

  • 2018/07/31 01:06

    申し訳ありません。
    755の権限が抜けておりました。

    ターミナルでの実行ですと、このようになります。↓

    Content-Type: text/html; charset=utf-8

    <!DOCTYPE html>
    <html>
    <head>
    <meta charset="utf-8x">
    <title>CGIスクリプト</title>
    </head>
    <body>
    <pre>

    おはようございます。
    Traceback (most recent call last):
    File "sample3.py", line 22, in <module>
    mc = MeCab.Tagger('-Ochasen')
    AttributeError: type object 'MeCab' has no attribute 'Tagger'

    </pre>
    </body>
    </html>


    ブラウザ上ですとこのようになります。↓

    おはようございます。
    Traceback (most recent call last):
    File "sample3.py", line 22, in
    mc = MeCab.Tagger('-Ochasen')
    AttributeError: type object 'MeCab' has no attribute 'Tagger'

    キャンセル

  • 2018/08/03 00:32

    引き続きこのようになりました。

    #!/usr/bin/env python3.4
    # -*- coding: utf-8 -*-

    import sys
    import io
    sys.stdout = io.TextIOWrapper(sys.stdout.buffer, encoding='utf8')

    import cgi
    # enable debugging
    import cgitb
    cgitb.enable()

    from natto import MeCab
    import traceback

    text = "おはようございます。"
    traceback_txt = ""
    ma = ""

    try:
    mc = MeCab()
    ma = mc.parse(text)
    except:
    #traceback_txt = logging.error(traceback.format_exc())
    traceback_txt = traceback.format_exc()
    ma = "形態素解析できませんでした。"

    #print("Content-Type: text/html; charset=utf-8\n\n")
    print("Content-Type: text/html; charset=utf8\n")
    print("""
    <!DOCTYPE html>
    <html>
    <head>
    <meta charset="utf8">
    <title>CGIスクリプト</title>
    </head>
    <body>
    <pre>
    """)
    print(text)
    print(ma)
    print(traceback_txt)
    print("""
    </pre>
    </body>
    </html>
    """)

    このソースですと、ターミナル上では形態素解析ができますが、
    ブラウザで表示させると以下のようになります。

    おはようございます。
    形態素解析できませんでした。
    Traceback (most recent call last):
    File "/home/trombone/.local/lib/python3.4/site-packages/natto/environment.py", line 144, in __get_libpath
    res = Popen(cmd, stdout=PIPE).communicate()
    File "/usr/lib64/python3.4/subprocess.py", line 856, in __init__
    restore_signals, start_new_session)
    File "/usr/lib64/python3.4/subprocess.py", line 1460, in _execute_child
    raise child_exception_type(errno_num, err_msg)
    FileNotFoundError: [Errno 2] No such file or directory: 'mecab-config'

    During handling of the above exception, another exception occurred:

    Traceback (most recent call last):
    File "/home/trombone/.local/lib/python3.4/site-packages/natto/mecab.py", line 147, in __init__
    env = MeCabEnv(**kwargs)
    File "/home/trombone/.local/lib/python3.4/site-packages/natto/environment.py", line 53, in __init__
    self.libpath = self.__get_libpath()
    File "/home/trombone/.local/lib/python3.4/site-packages/natto/environment.py", line 155, in __get_libpath
    raise EnvironmentError(self._ERROR_NOLIB.format(lib))
    OSError: libmecab.so could not be found, please use MECAB_PATH

    During handling of the above exception, another exception occurred:

    Traceback (most recent call last):
    File "sample21.py", line 26, in
    mc = MeCab()
    File "/home/trombone/.local/lib/python3.4/site-packages/natto/mecab.py", line 222, in __init__
    raise MeCabError(err)
    natto.api.MeCabError: libmecab.so could not be found, please use MECAB_PATH

    引き続き調べてみます。

    キャンセル

  • 2018/08/03 01:15

    CGIからパスとか環境変数とかあたりが見えてない結果な気がするので、その線でいろいろあたってみるべきかと

    キャンセル

  • 2018/08/03 01:36

    ありがとうございます。
    以下のようにできました!

    おはようございます。
    おはよう 感動詞,*,*,*,*,*,おはよう,オハヨウ,オハヨー
    ござい 助動詞,*,*,*,五段・ラ行特殊,連用形,ござる,ゴザイ,ゴザイ
    ます 助動詞,*,*,*,特殊・マス,基本形,ます,マス,マス
    。 記号,句点,*,*,*,*,。,。,。
    EOS

    最初、import osした際に,
    osでのpathの値をそのまま使えばいけると思い込んでいましたので、
    上手く表示できない際には、osライブラリは使えないのかと勘違いしてました。

    import os
    os.environ['MECAB_PATH'] = '/home/.../bin/mecab/lib/libmecab.so'
    os.environ['MECAB_CHARSET'] = 'utf8'

    と、こんな感じで書いてやる必要があったということでした。

    どうもありがとうございました!

    キャンセル

  • 2018/08/03 01:43 編集

    natto-pyのreadmeとかでそうしろって書いてあるんですか・・・
    なんでそれで行けるのかわからない(汗)なんかwebサーバ側でごにょごにょしないとダメかなぁ、とか思ってたんですが
    あと、ずいぶんナイーブなCGIですが、これから拡張していくならセキュリティとか気をつけてくださいね(ユーザの入力を受け取って~とかやりだすと色々考えるべきことが多いですね)。実験目的で、すぐ潰す予定のページとかならそこまでシビアに考える必要はないかもですけど

    キャンセル

  • 2018/08/07 10:58

    お返事が遅くなりまして申し訳ありません。
    そうですね、とりあえずは技術獲得のレベルですので、このままでは怖いですね。
    またよろしくお願いいたします。
    お忙しい中ありがとうございました。

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 90.33%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

同じタグがついた質問を見る

  • Python 3.x

    7412questions

    Python 3はPythonプログラミング言語の最新バージョンであり、2008年12月3日にリリースされました。

  • Mecab

    194questions

    Mecabは、オープンソースの形態素解析エンジンです。 言語、辞書、コーパスに依存しない汎用的な設計を基本方針としています。 Mecabの由来は、開発者の好物である和布蕪(めかぶ)から名づけられました。